%% RUN MESH
function handles = RUN_MESH(handles)

% Assign variables
NameInput = handles.NameInput;
NameOutput = handles.NameOutput;
HMax = handles.HMax;
JiggleIter = handles.JiggleIter;

%% BUILDING MESH
tic;
load(NameInput,'Database','BB','HH','PixelSize');
set(handles.listbox1,'String', ['Creating geometric data...'; get(handles.listbox1,'String')]);
% creating Decomposed Geometry matrix
MaxLength = 0;
for i = 1:length(Database)
    LengthSolid = size(Database(i).XY(1,1:int16(HMax/PixelSize):end-1),2);
    if LengthSolid >= MaxLength
        MaxLength = LengthSolid;
    end
end
gd = zeros(MaxLength,length(Database));
gd(1:10,1) = [3;4;2*PixelSize;(BB+1)*PixelSize;(BB+1)*PixelSize;2*PixelSize;2*PixelSize;2*PixelSize;(HH+1)*PixelSize;(HH+1)*PixelSize];
sf = 'R1';
ns = [82;49;0];
% for cyklus pres pouzite polygony
for i = 1:length(Database);
    % geometry description matrix
    SolidData = [2;size(Database(i).XY(1,1:int16(HMax/PixelSize):end-1),2);Database(i).XY(1,1:int16(HMax/PixelSize):end-1)';Database(i).XY(2,1:int16(HMax/PixelSize):end-1)'];
    gd(1:length(SolidData),i+1) = SolidData;
    % set formula sf
    sf = [sf,'-P',num2str(i)];
    % name space ns
    if i < 10
        ns(:,i+1) = [80;double(num2str(i));0];
    else
        ns(:,i+1) = [80;double(num2str(i))'];
    end
end
% decomposed geometry
set(handles.listbox1,'String', ['Decomposing geometry...'; get(handles.listbox1,'String')]);
dl = decsg(gd,sf,ns);
% mesh initialization
set(handles.listbox1,'String', ['Generating mesh...'; get(handles.listbox1,'String')]);
[p,e,t] = initmesh(dl,'Hmax',HMax,'JiggleIter',JiggleIter);
% save mesh to mesh.mat
set(handles.listbox1,'String', [['Saving mesh data to ',NameOutput,'.mat...']; get(handles.listbox1,'String')]);
save(NameOutput,'p','e','t');
handles.p = p;
handles.e = e;
handles.t = t;

set(handles.listbox1,'String', [['Time consumed ',num2str(toc),' sec'];'Done!'; get(handles.listbox1,'String')]);

