function draw_mesh(handles)
p = handles.p;
e = handles.e;
t = handles.t;
Numbering = handles.Numbering;

% plot mesh
figure(101),clf,hold all,axis equal;
title('Mesh'),xlabel('X'),ylabel('Y');
pdemesh(p,e,t);
switch Numbering
    case 1
        % nothing
    case 2
        % label edge points
        for i = 1:size(e,2)
            text(p(1,e(1,i)),p(2,e(1,i)),num2str(e(1,i)),'color',[0.3 0.7 0.3],'FontSize',8,'horizontalAlignment','left','verticalAlignment','bottom');
        end
    case 3
        % label all points
        for i = 1:length(p)
            text(p(1,i),p(2,i),num2str(i),'color',[0.3 0.7 0.3],'FontSize',8,'horizontalAlignment','left','verticalAlignment','bottom');
        end
    case 4
        % triangle labels
        for i = 1:length(t)
            x = ([p(1,t(1,i)),p(2,t(1,i))]+[p(1,t(2,i)),p(2,t(2,i))]+[p(1,t(3,i)),p(2,t(3,i))])/3;
            text(x(1),x(2),num2str(i),'color','black','FontSize',8,'horizontalAlignment','center','verticalAlignment','middle');
        end
    case 5
        % label all points
        for i = 1:length(p)
            text(p(1,i),p(2,i),num2str(i),'color',[0.3 0.7 0.3],'FontSize',8,'horizontalAlignment','left','verticalAlignment','bottom');
        end
        % triangle labels
        for i = 1:length(t)
            x = ([p(1,t(1,i)),p(2,t(1,i))]+[p(1,t(2,i)),p(2,t(2,i))]+[p(1,t(3,i)),p(2,t(3,i))])/3;
            text(x(1),x(2),num2str(i),'color','black','FontSize',8,'horizontalAlignment','center','verticalAlignment','middle');
        end
end


