%% RUN SOLVE
% loads mesh.mat data and computes 2D deformation, saves results in
% PdeMatlabSolve.txt or PdeOofemSolve.txt/vtu.
function handles = RUN_SOLVE(handles)
if exist(handles.BCInput, 'file')
    % read bc input
    C = importdata(handles.BCInput);
    fclose('all');
    for i = 1:length(C)
        eval(C{i});
    end
    % assign data
    PdeMode = handles.PDEMode;
    PlaneMode = handles.PlaneMode;
    EModulus = handles.EModulus;
    Nu = handles.Nu;
    Thickness = handles.Thickness;
    
    %% SOLUTION OF PDE
    if PdeMode == 1
        [handles.u,handles.defStr,handles.p,handles.e,handles.t] = matlabSolve(PlaneMode,EModulus,Nu,Thickness,NodeSupportX,NodeSupportY,NodeDisplcContrlX,NodeDisplcContrlY,NodeForceX,NodeForceY,Fx,Fy,ux,uy,handles);
    elseif PdeMode == 2
        if exist('oofem.exe', 'file')
            oofemSolve(PlaneMode,EModulus,Nu,Thickness,NodeSupportX,NodeSupportY,NodeDisplcContrlX,NodeDisplcContrlY,NodeForceX,NodeForceY,Fx,Fy,ux,uy,handles);
        else
            msgbox('oofem.exe file needed.');
        end
    end
else
    msgbox([handles.BCInput,' file does not exist.']);
end
