%% DRAW RESULTS
function red(handles)

u = handles.u;
defStr = handles.defStr;
p = handles.p;
e = handles.e;
t = handles.t;
draw = handles.draw;
scale = handles.scale;

k = 101;
switch draw
    case 1 % SigX
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,5),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\sigma_x');
    case 2 % SigY
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,6),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\sigma_y');
    case 3 % SigZ
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,7),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\sigma_z');
    case 4 % TauXY
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,8),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\tau_{xy}');
    case 5 % EpsX
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,1),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\epsilon_x');
    case 6 % EpsY
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,2),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\epsilon_y');
    case 7 % EpsZ
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,3),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\epsilon_z');
    case 8 % GamXY
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,4),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\gamma_{xy}');
    case 9 % def
        figure(k),clf,hold all,axis equal;
        plot(p(1,:),p(2,:),'.','Color','black','MarkerSize',4.5);
        % deformed mesh
        pdeplot(p+scale*[u(1:length(u)/2)';u(length(u)/2+1:end)'],e,t,...
            'xydata',((u(1:length(u)/2)').^2+(u(length(u)/2+1:end)').^2).^0.5,'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('Deformed mesh');
end
