%% DRAW RESULTS
draw = input('Draw:\n<1> SigX\n<2> SigY\n<3> SigZ\n<4> TauXY\n<5> EpsX\n<6> EpsY\n<7> EpsZ\n<8> GamXY\n<9> Displacement\n');
if isempty(draw)
    draw = -1;
end
if ~exist('k','var')
    k = 500;
end
switch draw
    case 1 % SigX
        figure(k),clf,hold all;
        pdeplot(p,e,t,'xydata',defStr(:,5),'colormap','Jet');
        axis equal,xlabel('X'),ylabel('Y'),title('\sigma_x');
        k = k+1;
    case 2 % SigY
        figure(k),clf,hold all;
        pdeplot(p,e,t,'xydata',defStr(:,6),'colormap','Jet');
        axis equal,xlabel('X'),ylabel('Y'),title('\sigma_y');
        k = k+1;
    case 3 % SigZ
        figure(k),clf,hold all;
        pdeplot(p,e,t,'xydata',defStr(:,7),'colormap','Jet');
        axis equal,xlabel('X'),ylabel('Y'),title('\sigma_z');
        k = k+1;
    case 4 % TauXY
        figure(k),clf,hold all;
        pdeplot(p,e,t,'xydata',defStr(:,8),'colormap','Jet');
        axis equal, xlabel('X'),ylabel('Y'),title('\tau_{xy}');
        k = k+1;
    case 5 % EpsX
        figure(k),clf,hold all,axis equal;
        pdeplot(p,e,t,'xydata',defStr(:,1),'colormap','Jet');
        xlabel('X'),ylabel('Y'),title('\epsilon_x');
        k = k+1;
    case 6 % EpsY
        figure(k),clf,hold all;
        pdeplot(p,e,t,'xydata',defStr(:,2),'colormap','Jet');
        axis equal,xlabel('X'),ylabel('Y'),title('\epsilon_y');
        k = k+1;
    case 7 % EpsZ
        figure(k),clf,hold all;
        pdeplot(p,e,t,'xydata',defStr(:,3),'colormap','Jet');
        axis equal,xlabel('X'),ylabel('Y'),title('\epsilon_z');
        k = k+1;
    case 8 % GamXY
        figure(k),clf,hold all;
        pdeplot(p,e,t,'xydata',defStr(:,4),'colormap','Jet');
        axis equal,xlabel('X'),ylabel('Y'),title('\gamma_{xy}');
        k = k+1;
    case 9 % def
        scale = input('Scale factor:\n');
        if isempty(scale)
            scale = 1;
        end;
        figure(k),clf,hold all;
        plot(p(1,:),p(2,:),'.','Color','black','MarkerSize',4.5);
        % deformed mesh
        pdeplot(p+scale*[u(1:length(u)/2)';u(length(u)/2+1:end)'],e,t,...
            'xydata',((u(1:length(u)/2)').^2+(u(length(u)/2+1:end)').^2).^0.5,'colormap','Jet');
        axis equal,xlabel('X'),ylabel('Y'),title('Deformed mesh');
        k = k+1;
    otherwise
        fprintf('Wrong input, please try again.\n')
end

fprintf('For new plot type "red+ENTER"\n');
